/*
 * generated by Xtext 2.25.0
 */
package org.xtext.example.methodname.services;

import com.google.inject.Inject;
import com.google.inject.Singleton;
import java.util.List;
import org.eclipse.xtext.Action;
import org.eclipse.xtext.Alternatives;
import org.eclipse.xtext.Assignment;
import org.eclipse.xtext.CrossReference;
import org.eclipse.xtext.EnumLiteralDeclaration;
import org.eclipse.xtext.EnumRule;
import org.eclipse.xtext.Grammar;
import org.eclipse.xtext.GrammarUtil;
import org.eclipse.xtext.Group;
import org.eclipse.xtext.Keyword;
import org.eclipse.xtext.ParserRule;
import org.eclipse.xtext.RuleCall;
import org.eclipse.xtext.TerminalRule;
import org.eclipse.xtext.common.services.TerminalsGrammarAccess;
import org.eclipse.xtext.service.AbstractElementFinder;
import org.eclipse.xtext.service.GrammarProvider;

@Singleton
public class MethodNameGrammarAccess extends AbstractElementFinder.AbstractGrammarElementFinder {
	
	public class ModelElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "org.xtext.example.methodname.MethodName.Model");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Keyword cDeclarationsKeyword_0 = (Keyword)cGroup.eContents().get(0);
		private final Assignment cDeclarationsAssignment_1 = (Assignment)cGroup.eContents().get(1);
		private final RuleCall cDeclarationsDeclarationParserRuleCall_1_0 = (RuleCall)cDeclarationsAssignment_1.eContents().get(0);
		private final Assignment cFixedDeclarationsAssignment_2 = (Assignment)cGroup.eContents().get(2);
		private final RuleCall cFixedDeclarationsFixedDeclarationParserRuleCall_2_0 = (RuleCall)cFixedDeclarationsAssignment_2.eContents().get(0);
		private final Keyword cRulesKeyword_3 = (Keyword)cGroup.eContents().get(3);
		private final Assignment cRulesAssignment_4 = (Assignment)cGroup.eContents().get(4);
		private final RuleCall cRulesRuleParserRuleCall_4_0 = (RuleCall)cRulesAssignment_4.eContents().get(0);
		private final Keyword cCasesKeyword_5 = (Keyword)cGroup.eContents().get(5);
		private final Assignment cElementsAssignment_6 = (Assignment)cGroup.eContents().get(6);
		private final RuleCall cElementsCaseParserRuleCall_6_0 = (RuleCall)cElementsAssignment_6.eContents().get(0);
		
		//Model:
		//    "declarations"
		//        declarations+=Declaration*
		//        fixedDeclarations+=FixedDeclaration+
		//    "rules"
		//        rules+=Rule*
		//    "cases"
		//        elements+=Case*
		//;
		@Override public ParserRule getRule() { return rule; }
		
		//"declarations"
		//    declarations+=Declaration*
		//    fixedDeclarations+=FixedDeclaration+
		//"rules"
		//    rules+=Rule*
		//"cases"
		//    elements+=Case*
		public Group getGroup() { return cGroup; }
		
		//"declarations"
		public Keyword getDeclarationsKeyword_0() { return cDeclarationsKeyword_0; }
		
		//declarations+=Declaration*
		public Assignment getDeclarationsAssignment_1() { return cDeclarationsAssignment_1; }
		
		//Declaration
		public RuleCall getDeclarationsDeclarationParserRuleCall_1_0() { return cDeclarationsDeclarationParserRuleCall_1_0; }
		
		//fixedDeclarations+=FixedDeclaration+
		public Assignment getFixedDeclarationsAssignment_2() { return cFixedDeclarationsAssignment_2; }
		
		//FixedDeclaration
		public RuleCall getFixedDeclarationsFixedDeclarationParserRuleCall_2_0() { return cFixedDeclarationsFixedDeclarationParserRuleCall_2_0; }
		
		//"rules"
		public Keyword getRulesKeyword_3() { return cRulesKeyword_3; }
		
		//rules+=Rule*
		public Assignment getRulesAssignment_4() { return cRulesAssignment_4; }
		
		//Rule
		public RuleCall getRulesRuleParserRuleCall_4_0() { return cRulesRuleParserRuleCall_4_0; }
		
		//"cases"
		public Keyword getCasesKeyword_5() { return cCasesKeyword_5; }
		
		//elements+=Case*
		public Assignment getElementsAssignment_6() { return cElementsAssignment_6; }
		
		//Case
		public RuleCall getElementsCaseParserRuleCall_6_0() { return cElementsCaseParserRuleCall_6_0; }
	}
	public class DeclarationElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "org.xtext.example.methodname.MethodName.Declaration");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Assignment cNameAssignment_0 = (Assignment)cGroup.eContents().get(0);
		private final RuleCall cNameIDTerminalRuleCall_0_0 = (RuleCall)cNameAssignment_0.eContents().get(0);
		private final Keyword cLessThanSignHyphenMinusGreaterThanSignKeyword_1 = (Keyword)cGroup.eContents().get(1);
		private final Assignment cPathAssignment_2 = (Assignment)cGroup.eContents().get(2);
		private final RuleCall cPathSTRINGTerminalRuleCall_2_0 = (RuleCall)cPathAssignment_2.eContents().get(0);
		
		//Declaration:
		//    name=ID "<->" path=STRING
		//;
		@Override public ParserRule getRule() { return rule; }
		
		//name=ID "<->" path=STRING
		public Group getGroup() { return cGroup; }
		
		//name=ID
		public Assignment getNameAssignment_0() { return cNameAssignment_0; }
		
		//ID
		public RuleCall getNameIDTerminalRuleCall_0_0() { return cNameIDTerminalRuleCall_0_0; }
		
		//"<->"
		public Keyword getLessThanSignHyphenMinusGreaterThanSignKeyword_1() { return cLessThanSignHyphenMinusGreaterThanSignKeyword_1; }
		
		//path=STRING
		public Assignment getPathAssignment_2() { return cPathAssignment_2; }
		
		//STRING
		public RuleCall getPathSTRINGTerminalRuleCall_2_0() { return cPathSTRINGTerminalRuleCall_2_0; }
	}
	public class FixedDeclarationElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "org.xtext.example.methodname.MethodName.FixedDeclaration");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Assignment cKindAssignment_0 = (Assignment)cGroup.eContents().get(0);
		private final RuleCall cKindKindEnumRuleCall_0_0 = (RuleCall)cKindAssignment_0.eContents().get(0);
		private final Keyword cLessThanSignHyphenMinusGreaterThanSignKeyword_1 = (Keyword)cGroup.eContents().get(1);
		private final Assignment cPathAssignment_2 = (Assignment)cGroup.eContents().get(2);
		private final RuleCall cPathSTRINGTerminalRuleCall_2_0 = (RuleCall)cPathAssignment_2.eContents().get(0);
		
		//FixedDeclaration:
		//    kind=Kind "<->" path=STRING
		//;
		@Override public ParserRule getRule() { return rule; }
		
		//kind=Kind "<->" path=STRING
		public Group getGroup() { return cGroup; }
		
		//kind=Kind
		public Assignment getKindAssignment_0() { return cKindAssignment_0; }
		
		//Kind
		public RuleCall getKindKindEnumRuleCall_0_0() { return cKindKindEnumRuleCall_0_0; }
		
		//"<->"
		public Keyword getLessThanSignHyphenMinusGreaterThanSignKeyword_1() { return cLessThanSignHyphenMinusGreaterThanSignKeyword_1; }
		
		//path=STRING
		public Assignment getPathAssignment_2() { return cPathAssignment_2; }
		
		//STRING
		public RuleCall getPathSTRINGTerminalRuleCall_2_0() { return cPathSTRINGTerminalRuleCall_2_0; }
	}
	public class RuleElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "org.xtext.example.methodname.MethodName.Rule");
		private final Alternatives cAlternatives = (Alternatives)rule.eContents().get(1);
		private final Group cGroup_0 = (Group)cAlternatives.eContents().get(0);
		private final Keyword cDefKeyword_0_0 = (Keyword)cGroup_0.eContents().get(0);
		private final Assignment cNameAssignment_0_1 = (Assignment)cGroup_0.eContents().get(1);
		private final RuleCall cNameIDTerminalRuleCall_0_1_0 = (RuleCall)cNameAssignment_0_1.eContents().get(0);
		private final Keyword cForKeyword_0_2 = (Keyword)cGroup_0.eContents().get(2);
		private final Assignment cKindAssignment_0_3 = (Assignment)cGroup_0.eContents().get(3);
		private final RuleCall cKindKindEnumRuleCall_0_3_0 = (RuleCall)cKindAssignment_0_3.eContents().get(0);
		private final Keyword cLeftCurlyBracketKeyword_0_4 = (Keyword)cGroup_0.eContents().get(4);
		private final Keyword cFilterKeyword_0_5 = (Keyword)cGroup_0.eContents().get(5);
		private final Assignment cDeclsAssignment_0_6 = (Assignment)cGroup_0.eContents().get(6);
		private final CrossReference cDeclsDeclarationCrossReference_0_6_0 = (CrossReference)cDeclsAssignment_0_6.eContents().get(0);
		private final RuleCall cDeclsDeclarationIDTerminalRuleCall_0_6_0_1 = (RuleCall)cDeclsDeclarationCrossReference_0_6_0.eContents().get(1);
		private final Group cGroup_0_7 = (Group)cGroup_0.eContents().get(7);
		private final Keyword cVerticalLineVerticalLineKeyword_0_7_0 = (Keyword)cGroup_0_7.eContents().get(0);
		private final Assignment cDeclsAssignment_0_7_1 = (Assignment)cGroup_0_7.eContents().get(1);
		private final CrossReference cDeclsDeclarationCrossReference_0_7_1_0 = (CrossReference)cDeclsAssignment_0_7_1.eContents().get(0);
		private final RuleCall cDeclsDeclarationIDTerminalRuleCall_0_7_1_0_1 = (RuleCall)cDeclsDeclarationCrossReference_0_7_1_0.eContents().get(1);
		private final Keyword cSuchKeyword_0_8 = (Keyword)cGroup_0.eContents().get(8);
		private final Keyword cThatKeyword_0_9 = (Keyword)cGroup_0.eContents().get(9);
		private final Keyword cSizeKeyword_0_10 = (Keyword)cGroup_0.eContents().get(10);
		private final Assignment cCompOpAssignment_0_11 = (Assignment)cGroup_0.eContents().get(11);
		private final Alternatives cCompOpAlternatives_0_11_0 = (Alternatives)cCompOpAssignment_0_11.eContents().get(0);
		private final Keyword cCompOpGreaterThanSignKeyword_0_11_0_0 = (Keyword)cCompOpAlternatives_0_11_0.eContents().get(0);
		private final Keyword cCompOpLessThanSignKeyword_0_11_0_1 = (Keyword)cCompOpAlternatives_0_11_0.eContents().get(1);
		private final Keyword cCompOpEqualsSignEqualsSignKeyword_0_11_0_2 = (Keyword)cCompOpAlternatives_0_11_0.eContents().get(2);
		private final Keyword cCompOpLessThanSignEqualsSignKeyword_0_11_0_3 = (Keyword)cCompOpAlternatives_0_11_0.eContents().get(3);
		private final Keyword cCompOpGreaterThanSignEqualsSignKeyword_0_11_0_4 = (Keyword)cCompOpAlternatives_0_11_0.eContents().get(4);
		private final Assignment cCompValueAssignment_0_12 = (Assignment)cGroup_0.eContents().get(12);
		private final RuleCall cCompValueINTTerminalRuleCall_0_12_0 = (RuleCall)cCompValueAssignment_0_12.eContents().get(0);
		private final Keyword cRightCurlyBracketKeyword_0_13 = (Keyword)cGroup_0.eContents().get(13);
		private final Group cGroup_1 = (Group)cAlternatives.eContents().get(1);
		private final Keyword cDefKeyword_1_0 = (Keyword)cGroup_1.eContents().get(0);
		private final Keyword cDeclareKeyword_1_1 = (Keyword)cGroup_1.eContents().get(1);
		private final Assignment cNameAssignment_1_2 = (Assignment)cGroup_1.eContents().get(2);
		private final RuleCall cNameIDTerminalRuleCall_1_2_0 = (RuleCall)cNameAssignment_1_2.eContents().get(0);
		
		//Rule:
		//    "def" name=ID "for" kind=Kind "{"
		//        "filter" decls+=[Declaration] ("||" decls+=[Declaration])*
		//        "such" "that" "size" compOp=(">"|"<"|"=="|"<="|">=") compValue=INT
		//    "}" |
		//    "def" "declare" name=ID
		//;
		@Override public ParserRule getRule() { return rule; }
		
		//"def" name=ID "for" kind=Kind "{"
		//    "filter" decls+=[Declaration] ("||" decls+=[Declaration])*
		//    "such" "that" "size" compOp=(">"|"<"|"=="|"<="|">=") compValue=INT
		//"}" |
		//"def" "declare" name=ID
		public Alternatives getAlternatives() { return cAlternatives; }
		
		//"def" name=ID "for" kind=Kind "{"
		//    "filter" decls+=[Declaration] ("||" decls+=[Declaration])*
		//    "such" "that" "size" compOp=(">"|"<"|"=="|"<="|">=") compValue=INT
		//"}"
		public Group getGroup_0() { return cGroup_0; }
		
		//"def"
		public Keyword getDefKeyword_0_0() { return cDefKeyword_0_0; }
		
		//name=ID
		public Assignment getNameAssignment_0_1() { return cNameAssignment_0_1; }
		
		//ID
		public RuleCall getNameIDTerminalRuleCall_0_1_0() { return cNameIDTerminalRuleCall_0_1_0; }
		
		//"for"
		public Keyword getForKeyword_0_2() { return cForKeyword_0_2; }
		
		//kind=Kind
		public Assignment getKindAssignment_0_3() { return cKindAssignment_0_3; }
		
		//Kind
		public RuleCall getKindKindEnumRuleCall_0_3_0() { return cKindKindEnumRuleCall_0_3_0; }
		
		//"{"
		public Keyword getLeftCurlyBracketKeyword_0_4() { return cLeftCurlyBracketKeyword_0_4; }
		
		//"filter"
		public Keyword getFilterKeyword_0_5() { return cFilterKeyword_0_5; }
		
		//decls+=[Declaration]
		public Assignment getDeclsAssignment_0_6() { return cDeclsAssignment_0_6; }
		
		//[Declaration]
		public CrossReference getDeclsDeclarationCrossReference_0_6_0() { return cDeclsDeclarationCrossReference_0_6_0; }
		
		//ID
		public RuleCall getDeclsDeclarationIDTerminalRuleCall_0_6_0_1() { return cDeclsDeclarationIDTerminalRuleCall_0_6_0_1; }
		
		//("||" decls+=[Declaration])*
		public Group getGroup_0_7() { return cGroup_0_7; }
		
		//"||"
		public Keyword getVerticalLineVerticalLineKeyword_0_7_0() { return cVerticalLineVerticalLineKeyword_0_7_0; }
		
		//decls+=[Declaration]
		public Assignment getDeclsAssignment_0_7_1() { return cDeclsAssignment_0_7_1; }
		
		//[Declaration]
		public CrossReference getDeclsDeclarationCrossReference_0_7_1_0() { return cDeclsDeclarationCrossReference_0_7_1_0; }
		
		//ID
		public RuleCall getDeclsDeclarationIDTerminalRuleCall_0_7_1_0_1() { return cDeclsDeclarationIDTerminalRuleCall_0_7_1_0_1; }
		
		//"such"
		public Keyword getSuchKeyword_0_8() { return cSuchKeyword_0_8; }
		
		//"that"
		public Keyword getThatKeyword_0_9() { return cThatKeyword_0_9; }
		
		//"size"
		public Keyword getSizeKeyword_0_10() { return cSizeKeyword_0_10; }
		
		//compOp=(">"|"<"|"=="|"<="|">=")
		public Assignment getCompOpAssignment_0_11() { return cCompOpAssignment_0_11; }
		
		//(">"|"<"|"=="|"<="|">=")
		public Alternatives getCompOpAlternatives_0_11_0() { return cCompOpAlternatives_0_11_0; }
		
		//">"
		public Keyword getCompOpGreaterThanSignKeyword_0_11_0_0() { return cCompOpGreaterThanSignKeyword_0_11_0_0; }
		
		//"<"
		public Keyword getCompOpLessThanSignKeyword_0_11_0_1() { return cCompOpLessThanSignKeyword_0_11_0_1; }
		
		//"=="
		public Keyword getCompOpEqualsSignEqualsSignKeyword_0_11_0_2() { return cCompOpEqualsSignEqualsSignKeyword_0_11_0_2; }
		
		//"<="
		public Keyword getCompOpLessThanSignEqualsSignKeyword_0_11_0_3() { return cCompOpLessThanSignEqualsSignKeyword_0_11_0_3; }
		
		//">="
		public Keyword getCompOpGreaterThanSignEqualsSignKeyword_0_11_0_4() { return cCompOpGreaterThanSignEqualsSignKeyword_0_11_0_4; }
		
		//compValue=INT
		public Assignment getCompValueAssignment_0_12() { return cCompValueAssignment_0_12; }
		
		//INT
		public RuleCall getCompValueINTTerminalRuleCall_0_12_0() { return cCompValueINTTerminalRuleCall_0_12_0; }
		
		//"}"
		public Keyword getRightCurlyBracketKeyword_0_13() { return cRightCurlyBracketKeyword_0_13; }
		
		//"def" "declare" name=ID
		public Group getGroup_1() { return cGroup_1; }
		
		//"def"
		public Keyword getDefKeyword_1_0() { return cDefKeyword_1_0; }
		
		//"declare"
		public Keyword getDeclareKeyword_1_1() { return cDeclareKeyword_1_1; }
		
		//name=ID
		public Assignment getNameAssignment_1_2() { return cNameAssignment_1_2; }
		
		//ID
		public RuleCall getNameIDTerminalRuleCall_1_2_0() { return cNameIDTerminalRuleCall_1_2_0; }
	}
	public class CaseElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "org.xtext.example.methodname.MethodName.Case");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Keyword cCaseKeyword_0 = (Keyword)cGroup.eContents().get(0);
		private final Keyword cForKeyword_1 = (Keyword)cGroup.eContents().get(1);
		private final Assignment cKindAssignment_2 = (Assignment)cGroup.eContents().get(2);
		private final RuleCall cKindKindEnumRuleCall_2_0 = (RuleCall)cKindAssignment_2.eContents().get(0);
		private final Assignment cConditionAssignment_3 = (Assignment)cGroup.eContents().get(3);
		private final RuleCall cConditionExprParserRuleCall_3_0 = (RuleCall)cConditionAssignment_3.eContents().get(0);
		private final Keyword cLeftCurlyBracketKeyword_4 = (Keyword)cGroup.eContents().get(4);
		private final Assignment cPropertiesAssignment_5 = (Assignment)cGroup.eContents().get(5);
		private final RuleCall cPropertiesPropertyParserRuleCall_5_0 = (RuleCall)cPropertiesAssignment_5.eContents().get(0);
		private final Keyword cRightCurlyBracketKeyword_6 = (Keyword)cGroup.eContents().get(6);
		
		//Case:
		//    "case" "for" kind=Kind condition=Expr "{"
		//        properties+=Property*
		//    "}"
		//;
		@Override public ParserRule getRule() { return rule; }
		
		//"case" "for" kind=Kind condition=Expr "{"
		//    properties+=Property*
		//"}"
		public Group getGroup() { return cGroup; }
		
		//"case"
		public Keyword getCaseKeyword_0() { return cCaseKeyword_0; }
		
		//"for"
		public Keyword getForKeyword_1() { return cForKeyword_1; }
		
		//kind=Kind
		public Assignment getKindAssignment_2() { return cKindAssignment_2; }
		
		//Kind
		public RuleCall getKindKindEnumRuleCall_2_0() { return cKindKindEnumRuleCall_2_0; }
		
		//condition=Expr
		public Assignment getConditionAssignment_3() { return cConditionAssignment_3; }
		
		//Expr
		public RuleCall getConditionExprParserRuleCall_3_0() { return cConditionExprParserRuleCall_3_0; }
		
		//"{"
		public Keyword getLeftCurlyBracketKeyword_4() { return cLeftCurlyBracketKeyword_4; }
		
		//properties+=Property*
		public Assignment getPropertiesAssignment_5() { return cPropertiesAssignment_5; }
		
		//Property
		public RuleCall getPropertiesPropertyParserRuleCall_5_0() { return cPropertiesPropertyParserRuleCall_5_0; }
		
		//"}"
		public Keyword getRightCurlyBracketKeyword_6() { return cRightCurlyBracketKeyword_6; }
	}
	public class ExprElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "org.xtext.example.methodname.MethodName.Expr");
		private final RuleCall cOrParserRuleCall = (RuleCall)rule.eContents().get(1);
		
		//Expr: Or;
		@Override public ParserRule getRule() { return rule; }
		
		//Or
		public RuleCall getOrParserRuleCall() { return cOrParserRuleCall; }
	}
	public class OrElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "org.xtext.example.methodname.MethodName.Or");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final RuleCall cAndParserRuleCall_0 = (RuleCall)cGroup.eContents().get(0);
		private final Group cGroup_1 = (Group)cGroup.eContents().get(1);
		private final Action cOrLeftAction_1_0 = (Action)cGroup_1.eContents().get(0);
		private final Keyword cVerticalLineKeyword_1_1 = (Keyword)cGroup_1.eContents().get(1);
		private final Assignment cRightAssignment_1_2 = (Assignment)cGroup_1.eContents().get(2);
		private final RuleCall cRightAndParserRuleCall_1_2_0 = (RuleCall)cRightAssignment_1_2.eContents().get(0);
		
		//Or returns Expr:
		//    And ({Or.left=current} "|" right=And)*;
		@Override public ParserRule getRule() { return rule; }
		
		//And ({Or.left=current} "|" right=And)*
		public Group getGroup() { return cGroup; }
		
		//And
		public RuleCall getAndParserRuleCall_0() { return cAndParserRuleCall_0; }
		
		//({Or.left=current} "|" right=And)*
		public Group getGroup_1() { return cGroup_1; }
		
		//{Or.left=current}
		public Action getOrLeftAction_1_0() { return cOrLeftAction_1_0; }
		
		//"|"
		public Keyword getVerticalLineKeyword_1_1() { return cVerticalLineKeyword_1_1; }
		
		//right=And
		public Assignment getRightAssignment_1_2() { return cRightAssignment_1_2; }
		
		//And
		public RuleCall getRightAndParserRuleCall_1_2_0() { return cRightAndParserRuleCall_1_2_0; }
	}
	public class AndElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "org.xtext.example.methodname.MethodName.And");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final RuleCall cPrimaryParserRuleCall_0 = (RuleCall)cGroup.eContents().get(0);
		private final Group cGroup_1 = (Group)cGroup.eContents().get(1);
		private final Action cAndLeftAction_1_0 = (Action)cGroup_1.eContents().get(0);
		private final Assignment cConcatKindAssignment_1_1 = (Assignment)cGroup_1.eContents().get(1);
		private final Alternatives cConcatKindAlternatives_1_1_0 = (Alternatives)cConcatKindAssignment_1_1.eContents().get(0);
		private final Keyword cConcatKindFullStopKeyword_1_1_0_0 = (Keyword)cConcatKindAlternatives_1_1_0.eContents().get(0);
		private final Keyword cConcatKindFullStopFullStopFullStopKeyword_1_1_0_1 = (Keyword)cConcatKindAlternatives_1_1_0.eContents().get(1);
		private final Assignment cRightAssignment_1_2 = (Assignment)cGroup_1.eContents().get(2);
		private final RuleCall cRightPrimaryParserRuleCall_1_2_0 = (RuleCall)cRightAssignment_1_2.eContents().get(0);
		
		//And returns Expr:
		//    Primary ({And.left=current} concatKind=("."|"...") right=Primary)*;
		@Override public ParserRule getRule() { return rule; }
		
		//Primary ({And.left=current} concatKind=("."|"...") right=Primary)*
		public Group getGroup() { return cGroup; }
		
		//Primary
		public RuleCall getPrimaryParserRuleCall_0() { return cPrimaryParserRuleCall_0; }
		
		//({And.left=current} concatKind=("."|"...") right=Primary)*
		public Group getGroup_1() { return cGroup_1; }
		
		//{And.left=current}
		public Action getAndLeftAction_1_0() { return cAndLeftAction_1_0; }
		
		//concatKind=("."|"...")
		public Assignment getConcatKindAssignment_1_1() { return cConcatKindAssignment_1_1; }
		
		//("."|"...")
		public Alternatives getConcatKindAlternatives_1_1_0() { return cConcatKindAlternatives_1_1_0; }
		
		//"."
		public Keyword getConcatKindFullStopKeyword_1_1_0_0() { return cConcatKindFullStopKeyword_1_1_0_0; }
		
		//"..."
		public Keyword getConcatKindFullStopFullStopFullStopKeyword_1_1_0_1() { return cConcatKindFullStopFullStopFullStopKeyword_1_1_0_1; }
		
		//right=Primary
		public Assignment getRightAssignment_1_2() { return cRightAssignment_1_2; }
		
		//Primary
		public RuleCall getRightPrimaryParserRuleCall_1_2_0() { return cRightPrimaryParserRuleCall_1_2_0; }
	}
	public class PrimaryElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "org.xtext.example.methodname.MethodName.Primary");
		private final Alternatives cAlternatives = (Alternatives)rule.eContents().get(1);
		private final RuleCall cGroupExprParserRuleCall_0 = (RuleCall)cAlternatives.eContents().get(0);
		private final RuleCall cAtomicParserRuleCall_1 = (RuleCall)cAlternatives.eContents().get(1);
		
		//Primary returns Expr:
		//    GroupExpr |
		//    Atomic
		//;
		@Override public ParserRule getRule() { return rule; }
		
		//GroupExpr |
		//Atomic
		public Alternatives getAlternatives() { return cAlternatives; }
		
		//GroupExpr
		public RuleCall getGroupExprParserRuleCall_0() { return cGroupExprParserRuleCall_0; }
		
		//Atomic
		public RuleCall getAtomicParserRuleCall_1() { return cAtomicParserRuleCall_1; }
	}
	public class GroupExprElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "org.xtext.example.methodname.MethodName.GroupExpr");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Assignment cHasNotAssignment_0 = (Assignment)cGroup.eContents().get(0);
		private final Keyword cHasNotExclamationMarkKeyword_0_0 = (Keyword)cHasNotAssignment_0.eContents().get(0);
		private final Keyword cLeftParenthesisKeyword_1 = (Keyword)cGroup.eContents().get(1);
		private final Assignment cExprAssignment_2 = (Assignment)cGroup.eContents().get(2);
		private final RuleCall cExprExprParserRuleCall_2_0 = (RuleCall)cExprAssignment_2.eContents().get(0);
		private final Keyword cRightParenthesisKeyword_3 = (Keyword)cGroup.eContents().get(3);
		private final Assignment cCardAssignment_4 = (Assignment)cGroup.eContents().get(4);
		private final RuleCall cCardCardinalityModifierEnumRuleCall_4_0 = (RuleCall)cCardAssignment_4.eContents().get(0);
		
		//GroupExpr:
		//    hasNot?="!"? "(" expr=Expr ")" card=CardinalityModifier?
		//;
		@Override public ParserRule getRule() { return rule; }
		
		//hasNot?="!"? "(" expr=Expr ")" card=CardinalityModifier?
		public Group getGroup() { return cGroup; }
		
		//hasNot?="!"?
		public Assignment getHasNotAssignment_0() { return cHasNotAssignment_0; }
		
		//"!"
		public Keyword getHasNotExclamationMarkKeyword_0_0() { return cHasNotExclamationMarkKeyword_0_0; }
		
		//"("
		public Keyword getLeftParenthesisKeyword_1() { return cLeftParenthesisKeyword_1; }
		
		//expr=Expr
		public Assignment getExprAssignment_2() { return cExprAssignment_2; }
		
		//Expr
		public RuleCall getExprExprParserRuleCall_2_0() { return cExprExprParserRuleCall_2_0; }
		
		//")"
		public Keyword getRightParenthesisKeyword_3() { return cRightParenthesisKeyword_3; }
		
		//card=CardinalityModifier?
		public Assignment getCardAssignment_4() { return cCardAssignment_4; }
		
		//CardinalityModifier
		public RuleCall getCardCardinalityModifierEnumRuleCall_4_0() { return cCardCardinalityModifierEnumRuleCall_4_0; }
	}
	public class AtomicElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "org.xtext.example.methodname.MethodName.Atomic");
		private final Alternatives cAlternatives = (Alternatives)rule.eContents().get(1);
		private final Group cGroup_0 = (Group)cAlternatives.eContents().get(0);
		private final Action cStringConstAction_0_0 = (Action)cGroup_0.eContents().get(0);
		private final Assignment cHasNotAssignment_0_1 = (Assignment)cGroup_0.eContents().get(1);
		private final Keyword cHasNotExclamationMarkKeyword_0_1_0 = (Keyword)cHasNotAssignment_0_1.eContents().get(0);
		private final Assignment cValueAssignment_0_2 = (Assignment)cGroup_0.eContents().get(2);
		private final RuleCall cValueSTRINGTerminalRuleCall_0_2_0 = (RuleCall)cValueAssignment_0_2.eContents().get(0);
		private final Assignment cCardAssignment_0_3 = (Assignment)cGroup_0.eContents().get(3);
		private final RuleCall cCardCardinalityModifierEnumRuleCall_0_3_0 = (RuleCall)cCardAssignment_0_3.eContents().get(0);
		private final Group cGroup_0_4 = (Group)cGroup_0.eContents().get(4);
		private final Keyword cLeftSquareBracketKeyword_0_4_0 = (Keyword)cGroup_0_4.eContents().get(0);
		private final Assignment cSentimentAssignment_0_4_1 = (Assignment)cGroup_0_4.eContents().get(1);
		private final RuleCall cSentimentSentimentEnumRuleCall_0_4_1_0 = (RuleCall)cSentimentAssignment_0_4_1.eContents().get(0);
		private final Keyword cRightSquareBracketKeyword_0_4_2 = (Keyword)cGroup_0_4.eContents().get(2);
		private final Group cGroup_1 = (Group)cAlternatives.eContents().get(1);
		private final Action cPOSValueAction_1_0 = (Action)cGroup_1.eContents().get(0);
		private final Assignment cHasNotAssignment_1_1 = (Assignment)cGroup_1.eContents().get(1);
		private final Keyword cHasNotExclamationMarkKeyword_1_1_0 = (Keyword)cHasNotAssignment_1_1.eContents().get(0);
		private final Assignment cPosAssignment_1_2 = (Assignment)cGroup_1.eContents().get(2);
		private final RuleCall cPosPOSEnumRuleCall_1_2_0 = (RuleCall)cPosAssignment_1_2.eContents().get(0);
		private final Assignment cCardAssignment_1_3 = (Assignment)cGroup_1.eContents().get(3);
		private final RuleCall cCardCardinalityModifierEnumRuleCall_1_3_0 = (RuleCall)cCardAssignment_1_3.eContents().get(0);
		private final Group cGroup_1_4 = (Group)cGroup_1.eContents().get(4);
		private final Keyword cLeftSquareBracketKeyword_1_4_0 = (Keyword)cGroup_1_4.eContents().get(0);
		private final Assignment cSentimentAssignment_1_4_1 = (Assignment)cGroup_1_4.eContents().get(1);
		private final RuleCall cSentimentSentimentEnumRuleCall_1_4_1_0 = (RuleCall)cSentimentAssignment_1_4_1.eContents().get(0);
		private final Keyword cRightSquareBracketKeyword_1_4_2 = (Keyword)cGroup_1_4.eContents().get(2);
		private final Group cGroup_2 = (Group)cAlternatives.eContents().get(2);
		private final Action cSynonymConstAction_2_0 = (Action)cGroup_2.eContents().get(0);
		private final Assignment cHasNotAssignment_2_1 = (Assignment)cGroup_2.eContents().get(1);
		private final Keyword cHasNotExclamationMarkKeyword_2_1_0 = (Keyword)cHasNotAssignment_2_1.eContents().get(0);
		private final Keyword cNumberSignKeyword_2_2 = (Keyword)cGroup_2.eContents().get(2);
		private final Assignment cValueAssignment_2_3 = (Assignment)cGroup_2.eContents().get(3);
		private final RuleCall cValueSTRINGTerminalRuleCall_2_3_0 = (RuleCall)cValueAssignment_2_3.eContents().get(0);
		private final Assignment cCardAssignment_2_4 = (Assignment)cGroup_2.eContents().get(4);
		private final RuleCall cCardCardinalityModifierEnumRuleCall_2_4_0 = (RuleCall)cCardAssignment_2_4.eContents().get(0);
		private final Group cGroup_2_5 = (Group)cGroup_2.eContents().get(5);
		private final Keyword cLeftSquareBracketKeyword_2_5_0 = (Keyword)cGroup_2_5.eContents().get(0);
		private final Assignment cSentimentAssignment_2_5_1 = (Assignment)cGroup_2_5.eContents().get(1);
		private final RuleCall cSentimentSentimentEnumRuleCall_2_5_1_0 = (RuleCall)cSentimentAssignment_2_5_1.eContents().get(0);
		private final Keyword cRightSquareBracketKeyword_2_5_2 = (Keyword)cGroup_2_5.eContents().get(2);
		
		//Atomic returns Expr:
		//    {StringConst}
		//        hasNot?="!"? value=STRING card=CardinalityModifier? ("[" sentiment=Sentiment "]")? |
		//    {POSValue}
		//        hasNot?="!"? pos=POS card=CardinalityModifier? ("[" sentiment=Sentiment "]")? |
		//    {SynonymConst}
		//        hasNot?="!"? "#" value=STRING card=CardinalityModifier? ("[" sentiment=Sentiment "]")?
		//;
		@Override public ParserRule getRule() { return rule; }
		
		//{StringConst}
		//    hasNot?="!"? value=STRING card=CardinalityModifier? ("[" sentiment=Sentiment "]")? |
		//{POSValue}
		//    hasNot?="!"? pos=POS card=CardinalityModifier? ("[" sentiment=Sentiment "]")? |
		//{SynonymConst}
		//    hasNot?="!"? "#" value=STRING card=CardinalityModifier? ("[" sentiment=Sentiment "]")?
		public Alternatives getAlternatives() { return cAlternatives; }
		
		//{StringConst}
		//    hasNot?="!"? value=STRING card=CardinalityModifier? ("[" sentiment=Sentiment "]")?
		public Group getGroup_0() { return cGroup_0; }
		
		//{StringConst}
		public Action getStringConstAction_0_0() { return cStringConstAction_0_0; }
		
		//hasNot?="!"?
		public Assignment getHasNotAssignment_0_1() { return cHasNotAssignment_0_1; }
		
		//"!"
		public Keyword getHasNotExclamationMarkKeyword_0_1_0() { return cHasNotExclamationMarkKeyword_0_1_0; }
		
		//value=STRING
		public Assignment getValueAssignment_0_2() { return cValueAssignment_0_2; }
		
		//STRING
		public RuleCall getValueSTRINGTerminalRuleCall_0_2_0() { return cValueSTRINGTerminalRuleCall_0_2_0; }
		
		//card=CardinalityModifier?
		public Assignment getCardAssignment_0_3() { return cCardAssignment_0_3; }
		
		//CardinalityModifier
		public RuleCall getCardCardinalityModifierEnumRuleCall_0_3_0() { return cCardCardinalityModifierEnumRuleCall_0_3_0; }
		
		//("[" sentiment=Sentiment "]")?
		public Group getGroup_0_4() { return cGroup_0_4; }
		
		//"["
		public Keyword getLeftSquareBracketKeyword_0_4_0() { return cLeftSquareBracketKeyword_0_4_0; }
		
		//sentiment=Sentiment
		public Assignment getSentimentAssignment_0_4_1() { return cSentimentAssignment_0_4_1; }
		
		//Sentiment
		public RuleCall getSentimentSentimentEnumRuleCall_0_4_1_0() { return cSentimentSentimentEnumRuleCall_0_4_1_0; }
		
		//"]"
		public Keyword getRightSquareBracketKeyword_0_4_2() { return cRightSquareBracketKeyword_0_4_2; }
		
		//{POSValue}
		//    hasNot?="!"? pos=POS card=CardinalityModifier? ("[" sentiment=Sentiment "]")?
		public Group getGroup_1() { return cGroup_1; }
		
		//{POSValue}
		public Action getPOSValueAction_1_0() { return cPOSValueAction_1_0; }
		
		//hasNot?="!"?
		public Assignment getHasNotAssignment_1_1() { return cHasNotAssignment_1_1; }
		
		//"!"
		public Keyword getHasNotExclamationMarkKeyword_1_1_0() { return cHasNotExclamationMarkKeyword_1_1_0; }
		
		//pos=POS
		public Assignment getPosAssignment_1_2() { return cPosAssignment_1_2; }
		
		//POS
		public RuleCall getPosPOSEnumRuleCall_1_2_0() { return cPosPOSEnumRuleCall_1_2_0; }
		
		//card=CardinalityModifier?
		public Assignment getCardAssignment_1_3() { return cCardAssignment_1_3; }
		
		//CardinalityModifier
		public RuleCall getCardCardinalityModifierEnumRuleCall_1_3_0() { return cCardCardinalityModifierEnumRuleCall_1_3_0; }
		
		//("[" sentiment=Sentiment "]")?
		public Group getGroup_1_4() { return cGroup_1_4; }
		
		//"["
		public Keyword getLeftSquareBracketKeyword_1_4_0() { return cLeftSquareBracketKeyword_1_4_0; }
		
		//sentiment=Sentiment
		public Assignment getSentimentAssignment_1_4_1() { return cSentimentAssignment_1_4_1; }
		
		//Sentiment
		public RuleCall getSentimentSentimentEnumRuleCall_1_4_1_0() { return cSentimentSentimentEnumRuleCall_1_4_1_0; }
		
		//"]"
		public Keyword getRightSquareBracketKeyword_1_4_2() { return cRightSquareBracketKeyword_1_4_2; }
		
		//{SynonymConst}
		//    hasNot?="!"? "#" value=STRING card=CardinalityModifier? ("[" sentiment=Sentiment "]")?
		public Group getGroup_2() { return cGroup_2; }
		
		//{SynonymConst}
		public Action getSynonymConstAction_2_0() { return cSynonymConstAction_2_0; }
		
		//hasNot?="!"?
		public Assignment getHasNotAssignment_2_1() { return cHasNotAssignment_2_1; }
		
		//"!"
		public Keyword getHasNotExclamationMarkKeyword_2_1_0() { return cHasNotExclamationMarkKeyword_2_1_0; }
		
		//"#"
		public Keyword getNumberSignKeyword_2_2() { return cNumberSignKeyword_2_2; }
		
		//value=STRING
		public Assignment getValueAssignment_2_3() { return cValueAssignment_2_3; }
		
		//STRING
		public RuleCall getValueSTRINGTerminalRuleCall_2_3_0() { return cValueSTRINGTerminalRuleCall_2_3_0; }
		
		//card=CardinalityModifier?
		public Assignment getCardAssignment_2_4() { return cCardAssignment_2_4; }
		
		//CardinalityModifier
		public RuleCall getCardCardinalityModifierEnumRuleCall_2_4_0() { return cCardCardinalityModifierEnumRuleCall_2_4_0; }
		
		//("[" sentiment=Sentiment "]")?
		public Group getGroup_2_5() { return cGroup_2_5; }
		
		//"["
		public Keyword getLeftSquareBracketKeyword_2_5_0() { return cLeftSquareBracketKeyword_2_5_0; }
		
		//sentiment=Sentiment
		public Assignment getSentimentAssignment_2_5_1() { return cSentimentAssignment_2_5_1; }
		
		//Sentiment
		public RuleCall getSentimentSentimentEnumRuleCall_2_5_1_0() { return cSentimentSentimentEnumRuleCall_2_5_1_0; }
		
		//"]"
		public Keyword getRightSquareBracketKeyword_2_5_2() { return cRightSquareBracketKeyword_2_5_2; }
	}
	public class PropertyElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "org.xtext.example.methodname.MethodName.Property");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Assignment cFrequencyAssignment_0 = (Assignment)cGroup.eContents().get(0);
		private final RuleCall cFrequencyFrequencyEnumRuleCall_0_0 = (RuleCall)cFrequencyAssignment_0.eContents().get(0);
		private final Assignment cCriterionAssignment_1 = (Assignment)cGroup.eContents().get(1);
		private final CrossReference cCriterionRuleCrossReference_1_0 = (CrossReference)cCriterionAssignment_1.eContents().get(0);
		private final RuleCall cCriterionRuleIDTerminalRuleCall_1_0_1 = (RuleCall)cCriterionRuleCrossReference_1_0.eContents().get(1);
		
		//Property:
		//    frequency=Frequency? criterion=[Rule];
		@Override public ParserRule getRule() { return rule; }
		
		//frequency=Frequency? criterion=[Rule]
		public Group getGroup() { return cGroup; }
		
		//frequency=Frequency?
		public Assignment getFrequencyAssignment_0() { return cFrequencyAssignment_0; }
		
		//Frequency
		public RuleCall getFrequencyFrequencyEnumRuleCall_0_0() { return cFrequencyFrequencyEnumRuleCall_0_0; }
		
		//criterion=[Rule]
		public Assignment getCriterionAssignment_1() { return cCriterionAssignment_1; }
		
		//[Rule]
		public CrossReference getCriterionRuleCrossReference_1_0() { return cCriterionRuleCrossReference_1_0; }
		
		//ID
		public RuleCall getCriterionRuleIDTerminalRuleCall_1_0_1() { return cCriterionRuleIDTerminalRuleCall_1_0_1; }
	}
	
	public class KindElements extends AbstractElementFinder.AbstractEnumRuleElementFinder {
		private final EnumRule rule = (EnumRule) GrammarUtil.findRuleForName(getGrammar(), "org.xtext.example.methodname.MethodName.Kind");
		private final Alternatives cAlternatives = (Alternatives)rule.eContents().get(1);
		private final EnumLiteralDeclaration cKIND_INTERFACEEnumLiteralDeclaration_0 = (EnumLiteralDeclaration)cAlternatives.eContents().get(0);
		private final Keyword cKIND_INTERFACEInterfaceKeyword_0_0 = (Keyword)cKIND_INTERFACEEnumLiteralDeclaration_0.eContents().get(0);
		private final EnumLiteralDeclaration cKIND_PACKAGEEnumLiteralDeclaration_1 = (EnumLiteralDeclaration)cAlternatives.eContents().get(1);
		private final Keyword cKIND_PACKAGEPackageKeyword_1_0 = (Keyword)cKIND_PACKAGEEnumLiteralDeclaration_1.eContents().get(0);
		private final EnumLiteralDeclaration cKIND_CLASSEnumLiteralDeclaration_2 = (EnumLiteralDeclaration)cAlternatives.eContents().get(2);
		private final Keyword cKIND_CLASSClassKeyword_2_0 = (Keyword)cKIND_CLASSEnumLiteralDeclaration_2.eContents().get(0);
		private final EnumLiteralDeclaration cKIND_METHODEnumLiteralDeclaration_3 = (EnumLiteralDeclaration)cAlternatives.eContents().get(3);
		private final Keyword cKIND_METHODMethodKeyword_3_0 = (Keyword)cKIND_METHODEnumLiteralDeclaration_3.eContents().get(0);
		private final EnumLiteralDeclaration cKIND_VAREnumLiteralDeclaration_4 = (EnumLiteralDeclaration)cAlternatives.eContents().get(4);
		private final Keyword cKIND_VARVariableKeyword_4_0 = (Keyword)cKIND_VAREnumLiteralDeclaration_4.eContents().get(0);
		
		//enum Kind:
		//    KIND_INTERFACE="interface"|
		//    KIND_PACKAGE="package" |
		//    KIND_CLASS="class" |
		//    KIND_METHOD="method" |
		//    KIND_VAR="variable"
		//;
		public EnumRule getRule() { return rule; }
		
		//KIND_INTERFACE="interface"|
		//KIND_PACKAGE="package" |
		//KIND_CLASS="class" |
		//KIND_METHOD="method" |
		//KIND_VAR="variable"
		public Alternatives getAlternatives() { return cAlternatives; }
		
		//KIND_INTERFACE="interface"
		public EnumLiteralDeclaration getKIND_INTERFACEEnumLiteralDeclaration_0() { return cKIND_INTERFACEEnumLiteralDeclaration_0; }
		
		//"interface"
		public Keyword getKIND_INTERFACEInterfaceKeyword_0_0() { return cKIND_INTERFACEInterfaceKeyword_0_0; }
		
		//KIND_PACKAGE="package"
		public EnumLiteralDeclaration getKIND_PACKAGEEnumLiteralDeclaration_1() { return cKIND_PACKAGEEnumLiteralDeclaration_1; }
		
		//"package"
		public Keyword getKIND_PACKAGEPackageKeyword_1_0() { return cKIND_PACKAGEPackageKeyword_1_0; }
		
		//KIND_CLASS="class"
		public EnumLiteralDeclaration getKIND_CLASSEnumLiteralDeclaration_2() { return cKIND_CLASSEnumLiteralDeclaration_2; }
		
		//"class"
		public Keyword getKIND_CLASSClassKeyword_2_0() { return cKIND_CLASSClassKeyword_2_0; }
		
		//KIND_METHOD="method"
		public EnumLiteralDeclaration getKIND_METHODEnumLiteralDeclaration_3() { return cKIND_METHODEnumLiteralDeclaration_3; }
		
		//"method"
		public Keyword getKIND_METHODMethodKeyword_3_0() { return cKIND_METHODMethodKeyword_3_0; }
		
		//KIND_VAR="variable"
		public EnumLiteralDeclaration getKIND_VAREnumLiteralDeclaration_4() { return cKIND_VAREnumLiteralDeclaration_4; }
		
		//"variable"
		public Keyword getKIND_VARVariableKeyword_4_0() { return cKIND_VARVariableKeyword_4_0; }
	}
	public class SentimentElements extends AbstractElementFinder.AbstractEnumRuleElementFinder {
		private final EnumRule rule = (EnumRule) GrammarUtil.findRuleForName(getGrammar(), "org.xtext.example.methodname.MethodName.Sentiment");
		private final Alternatives cAlternatives = (Alternatives)rule.eContents().get(1);
		private final EnumLiteralDeclaration cSENT_UNSPECIFIEDEnumLiteralDeclaration_0 = (EnumLiteralDeclaration)cAlternatives.eContents().get(0);
		private final Keyword cSENT_UNSPECIFIEDSENT_UNSPECIFIEDKeyword_0_0 = (Keyword)cSENT_UNSPECIFIEDEnumLiteralDeclaration_0.eContents().get(0);
		private final EnumLiteralDeclaration cSENT_NEUTRALEnumLiteralDeclaration_1 = (EnumLiteralDeclaration)cAlternatives.eContents().get(1);
		private final Keyword cSENT_NEUTRALNeutralKeyword_1_0 = (Keyword)cSENT_NEUTRALEnumLiteralDeclaration_1.eContents().get(0);
		private final EnumLiteralDeclaration cSENT_POSITIVEEnumLiteralDeclaration_2 = (EnumLiteralDeclaration)cAlternatives.eContents().get(2);
		private final Keyword cSENT_POSITIVEPositiveKeyword_2_0 = (Keyword)cSENT_POSITIVEEnumLiteralDeclaration_2.eContents().get(0);
		private final EnumLiteralDeclaration cSENT_NEGATIVEEnumLiteralDeclaration_3 = (EnumLiteralDeclaration)cAlternatives.eContents().get(3);
		private final Keyword cSENT_NEGATIVENegativeKeyword_3_0 = (Keyword)cSENT_NEGATIVEEnumLiteralDeclaration_3.eContents().get(0);
		
		//enum Sentiment:
		//    SENT_UNSPECIFIED |
		//    SENT_NEUTRAL="neutral" |
		//    SENT_POSITIVE="positive" |
		//    SENT_NEGATIVE="negative"
		//;
		public EnumRule getRule() { return rule; }
		
		//SENT_UNSPECIFIED |
		//SENT_NEUTRAL="neutral" |
		//SENT_POSITIVE="positive" |
		//SENT_NEGATIVE="negative"
		public Alternatives getAlternatives() { return cAlternatives; }
		
		//SENT_UNSPECIFIED
		public EnumLiteralDeclaration getSENT_UNSPECIFIEDEnumLiteralDeclaration_0() { return cSENT_UNSPECIFIEDEnumLiteralDeclaration_0; }
		
		public Keyword getSENT_UNSPECIFIEDSENT_UNSPECIFIEDKeyword_0_0() { return cSENT_UNSPECIFIEDSENT_UNSPECIFIEDKeyword_0_0; }
		
		//SENT_NEUTRAL="neutral"
		public EnumLiteralDeclaration getSENT_NEUTRALEnumLiteralDeclaration_1() { return cSENT_NEUTRALEnumLiteralDeclaration_1; }
		
		//"neutral"
		public Keyword getSENT_NEUTRALNeutralKeyword_1_0() { return cSENT_NEUTRALNeutralKeyword_1_0; }
		
		//SENT_POSITIVE="positive"
		public EnumLiteralDeclaration getSENT_POSITIVEEnumLiteralDeclaration_2() { return cSENT_POSITIVEEnumLiteralDeclaration_2; }
		
		//"positive"
		public Keyword getSENT_POSITIVEPositiveKeyword_2_0() { return cSENT_POSITIVEPositiveKeyword_2_0; }
		
		//SENT_NEGATIVE="negative"
		public EnumLiteralDeclaration getSENT_NEGATIVEEnumLiteralDeclaration_3() { return cSENT_NEGATIVEEnumLiteralDeclaration_3; }
		
		//"negative"
		public Keyword getSENT_NEGATIVENegativeKeyword_3_0() { return cSENT_NEGATIVENegativeKeyword_3_0; }
	}
	public class POSElements extends AbstractElementFinder.AbstractEnumRuleElementFinder {
		private final EnumRule rule = (EnumRule) GrammarUtil.findRuleForName(getGrammar(), "org.xtext.example.methodname.MethodName.POS");
		private final Alternatives cAlternatives = (Alternatives)rule.eContents().get(1);
		private final EnumLiteralDeclaration cPOS_CCEnumLiteralDeclaration_0 = (EnumLiteralDeclaration)cAlternatives.eContents().get(0);
		private final Keyword cPOS_CCCCKeyword_0_0 = (Keyword)cPOS_CCEnumLiteralDeclaration_0.eContents().get(0);
		private final EnumLiteralDeclaration cPOS_CDEnumLiteralDeclaration_1 = (EnumLiteralDeclaration)cAlternatives.eContents().get(1);
		private final Keyword cPOS_CDCDKeyword_1_0 = (Keyword)cPOS_CDEnumLiteralDeclaration_1.eContents().get(0);
		private final EnumLiteralDeclaration cPOS_DTEnumLiteralDeclaration_2 = (EnumLiteralDeclaration)cAlternatives.eContents().get(2);
		private final Keyword cPOS_DTDTKeyword_2_0 = (Keyword)cPOS_DTEnumLiteralDeclaration_2.eContents().get(0);
		private final EnumLiteralDeclaration cPOS_EXEnumLiteralDeclaration_3 = (EnumLiteralDeclaration)cAlternatives.eContents().get(3);
		private final Keyword cPOS_EXEXKeyword_3_0 = (Keyword)cPOS_EXEnumLiteralDeclaration_3.eContents().get(0);
		private final EnumLiteralDeclaration cPOS_FWEnumLiteralDeclaration_4 = (EnumLiteralDeclaration)cAlternatives.eContents().get(4);
		private final Keyword cPOS_FWFWKeyword_4_0 = (Keyword)cPOS_FWEnumLiteralDeclaration_4.eContents().get(0);
		private final EnumLiteralDeclaration cPOS_INEnumLiteralDeclaration_5 = (EnumLiteralDeclaration)cAlternatives.eContents().get(5);
		private final Keyword cPOS_ININKeyword_5_0 = (Keyword)cPOS_INEnumLiteralDeclaration_5.eContents().get(0);
		private final EnumLiteralDeclaration cPOS_JJEnumLiteralDeclaration_6 = (EnumLiteralDeclaration)cAlternatives.eContents().get(6);
		private final Keyword cPOS_JJJJKeyword_6_0 = (Keyword)cPOS_JJEnumLiteralDeclaration_6.eContents().get(0);
		private final EnumLiteralDeclaration cPOS_JJREnumLiteralDeclaration_7 = (EnumLiteralDeclaration)cAlternatives.eContents().get(7);
		private final Keyword cPOS_JJRJJRKeyword_7_0 = (Keyword)cPOS_JJREnumLiteralDeclaration_7.eContents().get(0);
		private final EnumLiteralDeclaration cPOS_JJSEnumLiteralDeclaration_8 = (EnumLiteralDeclaration)cAlternatives.eContents().get(8);
		private final Keyword cPOS_JJSJJSKeyword_8_0 = (Keyword)cPOS_JJSEnumLiteralDeclaration_8.eContents().get(0);
		private final EnumLiteralDeclaration cPOS_LSEnumLiteralDeclaration_9 = (EnumLiteralDeclaration)cAlternatives.eContents().get(9);
		private final Keyword cPOS_LSLSKeyword_9_0 = (Keyword)cPOS_LSEnumLiteralDeclaration_9.eContents().get(0);
		private final EnumLiteralDeclaration cPOS_MDEnumLiteralDeclaration_10 = (EnumLiteralDeclaration)cAlternatives.eContents().get(10);
		private final Keyword cPOS_MDMDKeyword_10_0 = (Keyword)cPOS_MDEnumLiteralDeclaration_10.eContents().get(0);
		private final EnumLiteralDeclaration cPOS_NNEnumLiteralDeclaration_11 = (EnumLiteralDeclaration)cAlternatives.eContents().get(11);
		private final Keyword cPOS_NNNNKeyword_11_0 = (Keyword)cPOS_NNEnumLiteralDeclaration_11.eContents().get(0);
		private final EnumLiteralDeclaration cPOS_NNSEnumLiteralDeclaration_12 = (EnumLiteralDeclaration)cAlternatives.eContents().get(12);
		private final Keyword cPOS_NNSNNSKeyword_12_0 = (Keyword)cPOS_NNSEnumLiteralDeclaration_12.eContents().get(0);
		private final EnumLiteralDeclaration cPOS_NNPEnumLiteralDeclaration_13 = (EnumLiteralDeclaration)cAlternatives.eContents().get(13);
		private final Keyword cPOS_NNPNNPKeyword_13_0 = (Keyword)cPOS_NNPEnumLiteralDeclaration_13.eContents().get(0);
		private final EnumLiteralDeclaration cPOS_NNPSEnumLiteralDeclaration_14 = (EnumLiteralDeclaration)cAlternatives.eContents().get(14);
		private final Keyword cPOS_NNPSNNPSKeyword_14_0 = (Keyword)cPOS_NNPSEnumLiteralDeclaration_14.eContents().get(0);
		private final EnumLiteralDeclaration cPOS_PDTEnumLiteralDeclaration_15 = (EnumLiteralDeclaration)cAlternatives.eContents().get(15);
		private final Keyword cPOS_PDTPDTKeyword_15_0 = (Keyword)cPOS_PDTEnumLiteralDeclaration_15.eContents().get(0);
		private final EnumLiteralDeclaration cPOS_POSEnumLiteralDeclaration_16 = (EnumLiteralDeclaration)cAlternatives.eContents().get(16);
		private final Keyword cPOS_POSPOSKeyword_16_0 = (Keyword)cPOS_POSEnumLiteralDeclaration_16.eContents().get(0);
		private final EnumLiteralDeclaration cPOS_PRPEnumLiteralDeclaration_17 = (EnumLiteralDeclaration)cAlternatives.eContents().get(17);
		private final Keyword cPOS_PRPPRPKeyword_17_0 = (Keyword)cPOS_PRPEnumLiteralDeclaration_17.eContents().get(0);
		private final EnumLiteralDeclaration cPOS_RBEnumLiteralDeclaration_18 = (EnumLiteralDeclaration)cAlternatives.eContents().get(18);
		private final Keyword cPOS_RBRBKeyword_18_0 = (Keyword)cPOS_RBEnumLiteralDeclaration_18.eContents().get(0);
		private final EnumLiteralDeclaration cPOS_RBREnumLiteralDeclaration_19 = (EnumLiteralDeclaration)cAlternatives.eContents().get(19);
		private final Keyword cPOS_RBRRBRKeyword_19_0 = (Keyword)cPOS_RBREnumLiteralDeclaration_19.eContents().get(0);
		private final EnumLiteralDeclaration cPOS_RBSEnumLiteralDeclaration_20 = (EnumLiteralDeclaration)cAlternatives.eContents().get(20);
		private final Keyword cPOS_RBSRBSKeyword_20_0 = (Keyword)cPOS_RBSEnumLiteralDeclaration_20.eContents().get(0);
		private final EnumLiteralDeclaration cPOS_RPEnumLiteralDeclaration_21 = (EnumLiteralDeclaration)cAlternatives.eContents().get(21);
		private final Keyword cPOS_RPRPKeyword_21_0 = (Keyword)cPOS_RPEnumLiteralDeclaration_21.eContents().get(0);
		private final EnumLiteralDeclaration cPOS_SYMEnumLiteralDeclaration_22 = (EnumLiteralDeclaration)cAlternatives.eContents().get(22);
		private final Keyword cPOS_SYMSYMKeyword_22_0 = (Keyword)cPOS_SYMEnumLiteralDeclaration_22.eContents().get(0);
		private final EnumLiteralDeclaration cPOS_TOEnumLiteralDeclaration_23 = (EnumLiteralDeclaration)cAlternatives.eContents().get(23);
		private final Keyword cPOS_TOTOKeyword_23_0 = (Keyword)cPOS_TOEnumLiteralDeclaration_23.eContents().get(0);
		private final EnumLiteralDeclaration cPOS_UHEnumLiteralDeclaration_24 = (EnumLiteralDeclaration)cAlternatives.eContents().get(24);
		private final Keyword cPOS_UHUHKeyword_24_0 = (Keyword)cPOS_UHEnumLiteralDeclaration_24.eContents().get(0);
		private final EnumLiteralDeclaration cPOS_VBEnumLiteralDeclaration_25 = (EnumLiteralDeclaration)cAlternatives.eContents().get(25);
		private final Keyword cPOS_VBVBKeyword_25_0 = (Keyword)cPOS_VBEnumLiteralDeclaration_25.eContents().get(0);
		private final EnumLiteralDeclaration cPOS_VBDEnumLiteralDeclaration_26 = (EnumLiteralDeclaration)cAlternatives.eContents().get(26);
		private final Keyword cPOS_VBDVBDKeyword_26_0 = (Keyword)cPOS_VBDEnumLiteralDeclaration_26.eContents().get(0);
		private final EnumLiteralDeclaration cPOS_VBGEnumLiteralDeclaration_27 = (EnumLiteralDeclaration)cAlternatives.eContents().get(27);
		private final Keyword cPOS_VBGVBGKeyword_27_0 = (Keyword)cPOS_VBGEnumLiteralDeclaration_27.eContents().get(0);
		private final EnumLiteralDeclaration cPOS_VBNEnumLiteralDeclaration_28 = (EnumLiteralDeclaration)cAlternatives.eContents().get(28);
		private final Keyword cPOS_VBNVBNKeyword_28_0 = (Keyword)cPOS_VBNEnumLiteralDeclaration_28.eContents().get(0);
		private final EnumLiteralDeclaration cPOS_VBPEnumLiteralDeclaration_29 = (EnumLiteralDeclaration)cAlternatives.eContents().get(29);
		private final Keyword cPOS_VBPVBPKeyword_29_0 = (Keyword)cPOS_VBPEnumLiteralDeclaration_29.eContents().get(0);
		private final EnumLiteralDeclaration cPOS_VBZEnumLiteralDeclaration_30 = (EnumLiteralDeclaration)cAlternatives.eContents().get(30);
		private final Keyword cPOS_VBZVBZKeyword_30_0 = (Keyword)cPOS_VBZEnumLiteralDeclaration_30.eContents().get(0);
		private final EnumLiteralDeclaration cPOS_WDTEnumLiteralDeclaration_31 = (EnumLiteralDeclaration)cAlternatives.eContents().get(31);
		private final Keyword cPOS_WDTWDTKeyword_31_0 = (Keyword)cPOS_WDTEnumLiteralDeclaration_31.eContents().get(0);
		private final EnumLiteralDeclaration cPOS_WPEnumLiteralDeclaration_32 = (EnumLiteralDeclaration)cAlternatives.eContents().get(32);
		private final Keyword cPOS_WPWPKeyword_32_0 = (Keyword)cPOS_WPEnumLiteralDeclaration_32.eContents().get(0);
		private final EnumLiteralDeclaration cPOS_WRBEnumLiteralDeclaration_33 = (EnumLiteralDeclaration)cAlternatives.eContents().get(33);
		private final Keyword cPOS_WRBWRBKeyword_33_0 = (Keyword)cPOS_WRBEnumLiteralDeclaration_33.eContents().get(0);
		
		//enum POS:
		//       POS_CC="CC" |
		//    POS_CD="CD" |
		//    POS_DT="DT" |
		//    POS_EX="EX" |
		//    POS_FW="FW" |
		//    POS_IN="IN" |
		//    POS_JJ="JJ" |
		//    POS_JJR="JJR" |
		//    POS_JJS="JJS" |
		//    POS_LS="LS" |
		//    POS_MD="MD" |
		//    POS_NN="NN" |
		//    POS_NNS="NNS" |
		//    POS_NNP="NNP" |
		//    POS_NNPS="NNPS" |
		//    POS_PDT="PDT" |
		//    POS_POS="POS" |
		//    POS_PRP="PRP" |
		//    POS_RB="RB" |
		//    POS_RBR="RBR" |
		//    POS_RBS="RBS" |
		//    POS_RP="RP" |
		//    POS_SYM="SYM" |
		//    POS_TO="TO" |
		//    POS_UH="UH" |
		//    POS_VB="VB" |
		//    POS_VBD="VBD" |
		//    POS_VBG="VBG" |
		//    POS_VBN="VBN" |
		//    POS_VBP="VBP" |
		//    POS_VBZ="VBZ" |
		//    POS_WDT="WDT" |
		//    POS_WP="WP" |
		//    POS_WRB="WRB"
		//;
		public EnumRule getRule() { return rule; }
		
		//   POS_CC="CC" |
		//POS_CD="CD" |
		//POS_DT="DT" |
		//POS_EX="EX" |
		//POS_FW="FW" |
		//POS_IN="IN" |
		//POS_JJ="JJ" |
		//POS_JJR="JJR" |
		//POS_JJS="JJS" |
		//POS_LS="LS" |
		//POS_MD="MD" |
		//POS_NN="NN" |
		//POS_NNS="NNS" |
		//POS_NNP="NNP" |
		//POS_NNPS="NNPS" |
		//POS_PDT="PDT" |
		//POS_POS="POS" |
		//POS_PRP="PRP" |
		//POS_RB="RB" |
		//POS_RBR="RBR" |
		//POS_RBS="RBS" |
		//POS_RP="RP" |
		//POS_SYM="SYM" |
		//POS_TO="TO" |
		//POS_UH="UH" |
		//POS_VB="VB" |
		//POS_VBD="VBD" |
		//POS_VBG="VBG" |
		//POS_VBN="VBN" |
		//POS_VBP="VBP" |
		//POS_VBZ="VBZ" |
		//POS_WDT="WDT" |
		//POS_WP="WP" |
		//POS_WRB="WRB"
		public Alternatives getAlternatives() { return cAlternatives; }
		
		//POS_CC="CC"
		public EnumLiteralDeclaration getPOS_CCEnumLiteralDeclaration_0() { return cPOS_CCEnumLiteralDeclaration_0; }
		
		//"CC"
		public Keyword getPOS_CCCCKeyword_0_0() { return cPOS_CCCCKeyword_0_0; }
		
		//POS_CD="CD"
		public EnumLiteralDeclaration getPOS_CDEnumLiteralDeclaration_1() { return cPOS_CDEnumLiteralDeclaration_1; }
		
		//"CD"
		public Keyword getPOS_CDCDKeyword_1_0() { return cPOS_CDCDKeyword_1_0; }
		
		//POS_DT="DT"
		public EnumLiteralDeclaration getPOS_DTEnumLiteralDeclaration_2() { return cPOS_DTEnumLiteralDeclaration_2; }
		
		//"DT"
		public Keyword getPOS_DTDTKeyword_2_0() { return cPOS_DTDTKeyword_2_0; }
		
		//POS_EX="EX"
		public EnumLiteralDeclaration getPOS_EXEnumLiteralDeclaration_3() { return cPOS_EXEnumLiteralDeclaration_3; }
		
		//"EX"
		public Keyword getPOS_EXEXKeyword_3_0() { return cPOS_EXEXKeyword_3_0; }
		
		//POS_FW="FW"
		public EnumLiteralDeclaration getPOS_FWEnumLiteralDeclaration_4() { return cPOS_FWEnumLiteralDeclaration_4; }
		
		//"FW"
		public Keyword getPOS_FWFWKeyword_4_0() { return cPOS_FWFWKeyword_4_0; }
		
		//POS_IN="IN"
		public EnumLiteralDeclaration getPOS_INEnumLiteralDeclaration_5() { return cPOS_INEnumLiteralDeclaration_5; }
		
		//"IN"
		public Keyword getPOS_ININKeyword_5_0() { return cPOS_ININKeyword_5_0; }
		
		//POS_JJ="JJ"
		public EnumLiteralDeclaration getPOS_JJEnumLiteralDeclaration_6() { return cPOS_JJEnumLiteralDeclaration_6; }
		
		//"JJ"
		public Keyword getPOS_JJJJKeyword_6_0() { return cPOS_JJJJKeyword_6_0; }
		
		//POS_JJR="JJR"
		public EnumLiteralDeclaration getPOS_JJREnumLiteralDeclaration_7() { return cPOS_JJREnumLiteralDeclaration_7; }
		
		//"JJR"
		public Keyword getPOS_JJRJJRKeyword_7_0() { return cPOS_JJRJJRKeyword_7_0; }
		
		//POS_JJS="JJS"
		public EnumLiteralDeclaration getPOS_JJSEnumLiteralDeclaration_8() { return cPOS_JJSEnumLiteralDeclaration_8; }
		
		//"JJS"
		public Keyword getPOS_JJSJJSKeyword_8_0() { return cPOS_JJSJJSKeyword_8_0; }
		
		//POS_LS="LS"
		public EnumLiteralDeclaration getPOS_LSEnumLiteralDeclaration_9() { return cPOS_LSEnumLiteralDeclaration_9; }
		
		//"LS"
		public Keyword getPOS_LSLSKeyword_9_0() { return cPOS_LSLSKeyword_9_0; }
		
		//POS_MD="MD"
		public EnumLiteralDeclaration getPOS_MDEnumLiteralDeclaration_10() { return cPOS_MDEnumLiteralDeclaration_10; }
		
		//"MD"
		public Keyword getPOS_MDMDKeyword_10_0() { return cPOS_MDMDKeyword_10_0; }
		
		//POS_NN="NN"
		public EnumLiteralDeclaration getPOS_NNEnumLiteralDeclaration_11() { return cPOS_NNEnumLiteralDeclaration_11; }
		
		//"NN"
		public Keyword getPOS_NNNNKeyword_11_0() { return cPOS_NNNNKeyword_11_0; }
		
		//POS_NNS="NNS"
		public EnumLiteralDeclaration getPOS_NNSEnumLiteralDeclaration_12() { return cPOS_NNSEnumLiteralDeclaration_12; }
		
		//"NNS"
		public Keyword getPOS_NNSNNSKeyword_12_0() { return cPOS_NNSNNSKeyword_12_0; }
		
		//POS_NNP="NNP"
		public EnumLiteralDeclaration getPOS_NNPEnumLiteralDeclaration_13() { return cPOS_NNPEnumLiteralDeclaration_13; }
		
		//"NNP"
		public Keyword getPOS_NNPNNPKeyword_13_0() { return cPOS_NNPNNPKeyword_13_0; }
		
		//POS_NNPS="NNPS"
		public EnumLiteralDeclaration getPOS_NNPSEnumLiteralDeclaration_14() { return cPOS_NNPSEnumLiteralDeclaration_14; }
		
		//"NNPS"
		public Keyword getPOS_NNPSNNPSKeyword_14_0() { return cPOS_NNPSNNPSKeyword_14_0; }
		
		//POS_PDT="PDT"
		public EnumLiteralDeclaration getPOS_PDTEnumLiteralDeclaration_15() { return cPOS_PDTEnumLiteralDeclaration_15; }
		
		//"PDT"
		public Keyword getPOS_PDTPDTKeyword_15_0() { return cPOS_PDTPDTKeyword_15_0; }
		
		//POS_POS="POS"
		public EnumLiteralDeclaration getPOS_POSEnumLiteralDeclaration_16() { return cPOS_POSEnumLiteralDeclaration_16; }
		
		//"POS"
		public Keyword getPOS_POSPOSKeyword_16_0() { return cPOS_POSPOSKeyword_16_0; }
		
		//POS_PRP="PRP"
		public EnumLiteralDeclaration getPOS_PRPEnumLiteralDeclaration_17() { return cPOS_PRPEnumLiteralDeclaration_17; }
		
		//"PRP"
		public Keyword getPOS_PRPPRPKeyword_17_0() { return cPOS_PRPPRPKeyword_17_0; }
		
		//POS_RB="RB"
		public EnumLiteralDeclaration getPOS_RBEnumLiteralDeclaration_18() { return cPOS_RBEnumLiteralDeclaration_18; }
		
		//"RB"
		public Keyword getPOS_RBRBKeyword_18_0() { return cPOS_RBRBKeyword_18_0; }
		
		//POS_RBR="RBR"
		public EnumLiteralDeclaration getPOS_RBREnumLiteralDeclaration_19() { return cPOS_RBREnumLiteralDeclaration_19; }
		
		//"RBR"
		public Keyword getPOS_RBRRBRKeyword_19_0() { return cPOS_RBRRBRKeyword_19_0; }
		
		//POS_RBS="RBS"
		public EnumLiteralDeclaration getPOS_RBSEnumLiteralDeclaration_20() { return cPOS_RBSEnumLiteralDeclaration_20; }
		
		//"RBS"
		public Keyword getPOS_RBSRBSKeyword_20_0() { return cPOS_RBSRBSKeyword_20_0; }
		
		//POS_RP="RP"
		public EnumLiteralDeclaration getPOS_RPEnumLiteralDeclaration_21() { return cPOS_RPEnumLiteralDeclaration_21; }
		
		//"RP"
		public Keyword getPOS_RPRPKeyword_21_0() { return cPOS_RPRPKeyword_21_0; }
		
		//POS_SYM="SYM"
		public EnumLiteralDeclaration getPOS_SYMEnumLiteralDeclaration_22() { return cPOS_SYMEnumLiteralDeclaration_22; }
		
		//"SYM"
		public Keyword getPOS_SYMSYMKeyword_22_0() { return cPOS_SYMSYMKeyword_22_0; }
		
		//POS_TO="TO"
		public EnumLiteralDeclaration getPOS_TOEnumLiteralDeclaration_23() { return cPOS_TOEnumLiteralDeclaration_23; }
		
		//"TO"
		public Keyword getPOS_TOTOKeyword_23_0() { return cPOS_TOTOKeyword_23_0; }
		
		//POS_UH="UH"
		public EnumLiteralDeclaration getPOS_UHEnumLiteralDeclaration_24() { return cPOS_UHEnumLiteralDeclaration_24; }
		
		//"UH"
		public Keyword getPOS_UHUHKeyword_24_0() { return cPOS_UHUHKeyword_24_0; }
		
		//POS_VB="VB"
		public EnumLiteralDeclaration getPOS_VBEnumLiteralDeclaration_25() { return cPOS_VBEnumLiteralDeclaration_25; }
		
		//"VB"
		public Keyword getPOS_VBVBKeyword_25_0() { return cPOS_VBVBKeyword_25_0; }
		
		//POS_VBD="VBD"
		public EnumLiteralDeclaration getPOS_VBDEnumLiteralDeclaration_26() { return cPOS_VBDEnumLiteralDeclaration_26; }
		
		//"VBD"
		public Keyword getPOS_VBDVBDKeyword_26_0() { return cPOS_VBDVBDKeyword_26_0; }
		
		//POS_VBG="VBG"
		public EnumLiteralDeclaration getPOS_VBGEnumLiteralDeclaration_27() { return cPOS_VBGEnumLiteralDeclaration_27; }
		
		//"VBG"
		public Keyword getPOS_VBGVBGKeyword_27_0() { return cPOS_VBGVBGKeyword_27_0; }
		
		//POS_VBN="VBN"
		public EnumLiteralDeclaration getPOS_VBNEnumLiteralDeclaration_28() { return cPOS_VBNEnumLiteralDeclaration_28; }
		
		//"VBN"
		public Keyword getPOS_VBNVBNKeyword_28_0() { return cPOS_VBNVBNKeyword_28_0; }
		
		//POS_VBP="VBP"
		public EnumLiteralDeclaration getPOS_VBPEnumLiteralDeclaration_29() { return cPOS_VBPEnumLiteralDeclaration_29; }
		
		//"VBP"
		public Keyword getPOS_VBPVBPKeyword_29_0() { return cPOS_VBPVBPKeyword_29_0; }
		
		//POS_VBZ="VBZ"
		public EnumLiteralDeclaration getPOS_VBZEnumLiteralDeclaration_30() { return cPOS_VBZEnumLiteralDeclaration_30; }
		
		//"VBZ"
		public Keyword getPOS_VBZVBZKeyword_30_0() { return cPOS_VBZVBZKeyword_30_0; }
		
		//POS_WDT="WDT"
		public EnumLiteralDeclaration getPOS_WDTEnumLiteralDeclaration_31() { return cPOS_WDTEnumLiteralDeclaration_31; }
		
		//"WDT"
		public Keyword getPOS_WDTWDTKeyword_31_0() { return cPOS_WDTWDTKeyword_31_0; }
		
		//POS_WP="WP"
		public EnumLiteralDeclaration getPOS_WPEnumLiteralDeclaration_32() { return cPOS_WPEnumLiteralDeclaration_32; }
		
		//"WP"
		public Keyword getPOS_WPWPKeyword_32_0() { return cPOS_WPWPKeyword_32_0; }
		
		//POS_WRB="WRB"
		public EnumLiteralDeclaration getPOS_WRBEnumLiteralDeclaration_33() { return cPOS_WRBEnumLiteralDeclaration_33; }
		
		//"WRB"
		public Keyword getPOS_WRBWRBKeyword_33_0() { return cPOS_WRBWRBKeyword_33_0; }
	}
	public class CardinalityModifierElements extends AbstractElementFinder.AbstractEnumRuleElementFinder {
		private final EnumRule rule = (EnumRule) GrammarUtil.findRuleForName(getGrammar(), "org.xtext.example.methodname.MethodName.CardinalityModifier");
		private final Alternatives cAlternatives = (Alternatives)rule.eContents().get(1);
		private final EnumLiteralDeclaration cCARD_1EnumLiteralDeclaration_0 = (EnumLiteralDeclaration)cAlternatives.eContents().get(0);
		private final Keyword cCARD_1CARD_1Keyword_0_0 = (Keyword)cCARD_1EnumLiteralDeclaration_0.eContents().get(0);
		private final EnumLiteralDeclaration cCARD_0_NEnumLiteralDeclaration_1 = (EnumLiteralDeclaration)cAlternatives.eContents().get(1);
		private final Keyword cCARD_0_NAsteriskKeyword_1_0 = (Keyword)cCARD_0_NEnumLiteralDeclaration_1.eContents().get(0);
		private final EnumLiteralDeclaration cCARD_1_NEnumLiteralDeclaration_2 = (EnumLiteralDeclaration)cAlternatives.eContents().get(2);
		private final Keyword cCARD_1_NPlusSignKeyword_2_0 = (Keyword)cCARD_1_NEnumLiteralDeclaration_2.eContents().get(0);
		private final EnumLiteralDeclaration cCARD_0_1EnumLiteralDeclaration_3 = (EnumLiteralDeclaration)cAlternatives.eContents().get(3);
		private final Keyword cCARD_0_1QuestionMarkKeyword_3_0 = (Keyword)cCARD_0_1EnumLiteralDeclaration_3.eContents().get(0);
		
		//enum CardinalityModifier:
		//    CARD_1 |
		//    CARD_0_N="*" |
		//    CARD_1_N="+" |
		//    CARD_0_1="?"
		//;
		public EnumRule getRule() { return rule; }
		
		//CARD_1 |
		//CARD_0_N="*" |
		//CARD_1_N="+" |
		//CARD_0_1="?"
		public Alternatives getAlternatives() { return cAlternatives; }
		
		//CARD_1
		public EnumLiteralDeclaration getCARD_1EnumLiteralDeclaration_0() { return cCARD_1EnumLiteralDeclaration_0; }
		
		public Keyword getCARD_1CARD_1Keyword_0_0() { return cCARD_1CARD_1Keyword_0_0; }
		
		//CARD_0_N="*"
		public EnumLiteralDeclaration getCARD_0_NEnumLiteralDeclaration_1() { return cCARD_0_NEnumLiteralDeclaration_1; }
		
		//"*"
		public Keyword getCARD_0_NAsteriskKeyword_1_0() { return cCARD_0_NAsteriskKeyword_1_0; }
		
		//CARD_1_N="+"
		public EnumLiteralDeclaration getCARD_1_NEnumLiteralDeclaration_2() { return cCARD_1_NEnumLiteralDeclaration_2; }
		
		//"+"
		public Keyword getCARD_1_NPlusSignKeyword_2_0() { return cCARD_1_NPlusSignKeyword_2_0; }
		
		//CARD_0_1="?"
		public EnumLiteralDeclaration getCARD_0_1EnumLiteralDeclaration_3() { return cCARD_0_1EnumLiteralDeclaration_3; }
		
		//"?"
		public Keyword getCARD_0_1QuestionMarkKeyword_3_0() { return cCARD_0_1QuestionMarkKeyword_3_0; }
	}
	public class FrequencyElements extends AbstractElementFinder.AbstractEnumRuleElementFinder {
		private final EnumRule rule = (EnumRule) GrammarUtil.findRuleForName(getGrammar(), "org.xtext.example.methodname.MethodName.Frequency");
		private final Alternatives cAlternatives = (Alternatives)rule.eContents().get(1);
		private final EnumLiteralDeclaration cALWAYSEnumLiteralDeclaration_0 = (EnumLiteralDeclaration)cAlternatives.eContents().get(0);
		private final Keyword cALWAYSAlwaysKeyword_0_0 = (Keyword)cALWAYSEnumLiteralDeclaration_0.eContents().get(0);
		private final EnumLiteralDeclaration cVERYOFTENEnumLiteralDeclaration_1 = (EnumLiteralDeclaration)cAlternatives.eContents().get(1);
		private final Keyword cVERYOFTENVeryOftenKeyword_1_0 = (Keyword)cVERYOFTENEnumLiteralDeclaration_1.eContents().get(0);
		private final EnumLiteralDeclaration cOFTEEnumLiteralDeclaration_2 = (EnumLiteralDeclaration)cAlternatives.eContents().get(2);
		private final Keyword cOFTEOftenKeyword_2_0 = (Keyword)cOFTEEnumLiteralDeclaration_2.eContents().get(0);
		private final EnumLiteralDeclaration cRARELYEnumLiteralDeclaration_3 = (EnumLiteralDeclaration)cAlternatives.eContents().get(3);
		private final Keyword cRARELYRarelyKeyword_3_0 = (Keyword)cRARELYEnumLiteralDeclaration_3.eContents().get(0);
		private final EnumLiteralDeclaration cVERYSELDOMEnumLiteralDeclaration_4 = (EnumLiteralDeclaration)cAlternatives.eContents().get(4);
		private final Keyword cVERYSELDOMVerySeldomKeyword_4_0 = (Keyword)cVERYSELDOMEnumLiteralDeclaration_4.eContents().get(0);
		private final EnumLiteralDeclaration cNEVEREnumLiteralDeclaration_5 = (EnumLiteralDeclaration)cAlternatives.eContents().get(5);
		private final Keyword cNEVERNeverKeyword_5_0 = (Keyword)cNEVEREnumLiteralDeclaration_5.eContents().get(0);
		
		//enum Frequency:
		//    ALWAYS="always" |
		//    VERYOFTEN="very-often" |
		//    OFTE="often" |
		//    RARELY="rarely" |
		//    VERYSELDOM="very-seldom" |
		//    NEVER="never"
		//;
		public EnumRule getRule() { return rule; }
		
		//ALWAYS="always" |
		//VERYOFTEN="very-often" |
		//OFTE="often" |
		//RARELY="rarely" |
		//VERYSELDOM="very-seldom" |
		//NEVER="never"
		public Alternatives getAlternatives() { return cAlternatives; }
		
		//ALWAYS="always"
		public EnumLiteralDeclaration getALWAYSEnumLiteralDeclaration_0() { return cALWAYSEnumLiteralDeclaration_0; }
		
		//"always"
		public Keyword getALWAYSAlwaysKeyword_0_0() { return cALWAYSAlwaysKeyword_0_0; }
		
		//VERYOFTEN="very-often"
		public EnumLiteralDeclaration getVERYOFTENEnumLiteralDeclaration_1() { return cVERYOFTENEnumLiteralDeclaration_1; }
		
		//"very-often"
		public Keyword getVERYOFTENVeryOftenKeyword_1_0() { return cVERYOFTENVeryOftenKeyword_1_0; }
		
		//OFTE="often"
		public EnumLiteralDeclaration getOFTEEnumLiteralDeclaration_2() { return cOFTEEnumLiteralDeclaration_2; }
		
		//"often"
		public Keyword getOFTEOftenKeyword_2_0() { return cOFTEOftenKeyword_2_0; }
		
		//RARELY="rarely"
		public EnumLiteralDeclaration getRARELYEnumLiteralDeclaration_3() { return cRARELYEnumLiteralDeclaration_3; }
		
		//"rarely"
		public Keyword getRARELYRarelyKeyword_3_0() { return cRARELYRarelyKeyword_3_0; }
		
		//VERYSELDOM="very-seldom"
		public EnumLiteralDeclaration getVERYSELDOMEnumLiteralDeclaration_4() { return cVERYSELDOMEnumLiteralDeclaration_4; }
		
		//"very-seldom"
		public Keyword getVERYSELDOMVerySeldomKeyword_4_0() { return cVERYSELDOMVerySeldomKeyword_4_0; }
		
		//NEVER="never"
		public EnumLiteralDeclaration getNEVEREnumLiteralDeclaration_5() { return cNEVEREnumLiteralDeclaration_5; }
		
		//"never"
		public Keyword getNEVERNeverKeyword_5_0() { return cNEVERNeverKeyword_5_0; }
	}
	
	private final ModelElements pModel;
	private final DeclarationElements pDeclaration;
	private final FixedDeclarationElements pFixedDeclaration;
	private final KindElements eKind;
	private final RuleElements pRule;
	private final CaseElements pCase;
	private final ExprElements pExpr;
	private final OrElements pOr;
	private final AndElements pAnd;
	private final PrimaryElements pPrimary;
	private final GroupExprElements pGroupExpr;
	private final AtomicElements pAtomic;
	private final SentimentElements eSentiment;
	private final POSElements ePOS;
	private final CardinalityModifierElements eCardinalityModifier;
	private final PropertyElements pProperty;
	private final FrequencyElements eFrequency;
	
	private final Grammar grammar;
	
	private final TerminalsGrammarAccess gaTerminals;

	@Inject
	public MethodNameGrammarAccess(GrammarProvider grammarProvider,
			TerminalsGrammarAccess gaTerminals) {
		this.grammar = internalFindGrammar(grammarProvider);
		this.gaTerminals = gaTerminals;
		this.pModel = new ModelElements();
		this.pDeclaration = new DeclarationElements();
		this.pFixedDeclaration = new FixedDeclarationElements();
		this.eKind = new KindElements();
		this.pRule = new RuleElements();
		this.pCase = new CaseElements();
		this.pExpr = new ExprElements();
		this.pOr = new OrElements();
		this.pAnd = new AndElements();
		this.pPrimary = new PrimaryElements();
		this.pGroupExpr = new GroupExprElements();
		this.pAtomic = new AtomicElements();
		this.eSentiment = new SentimentElements();
		this.ePOS = new POSElements();
		this.eCardinalityModifier = new CardinalityModifierElements();
		this.pProperty = new PropertyElements();
		this.eFrequency = new FrequencyElements();
	}
	
	protected Grammar internalFindGrammar(GrammarProvider grammarProvider) {
		Grammar grammar = grammarProvider.getGrammar(this);
		while (grammar != null) {
			if ("org.xtext.example.methodname.MethodName".equals(grammar.getName())) {
				return grammar;
			}
			List<Grammar> grammars = grammar.getUsedGrammars();
			if (!grammars.isEmpty()) {
				grammar = grammars.iterator().next();
			} else {
				return null;
			}
		}
		return grammar;
	}
	
	@Override
	public Grammar getGrammar() {
		return grammar;
	}
	
	
	public TerminalsGrammarAccess getTerminalsGrammarAccess() {
		return gaTerminals;
	}

	
	//Model:
	//    "declarations"
	//        declarations+=Declaration*
	//        fixedDeclarations+=FixedDeclaration+
	//    "rules"
	//        rules+=Rule*
	//    "cases"
	//        elements+=Case*
	//;
	public ModelElements getModelAccess() {
		return pModel;
	}
	
	public ParserRule getModelRule() {
		return getModelAccess().getRule();
	}
	
	//Declaration:
	//    name=ID "<->" path=STRING
	//;
	public DeclarationElements getDeclarationAccess() {
		return pDeclaration;
	}
	
	public ParserRule getDeclarationRule() {
		return getDeclarationAccess().getRule();
	}
	
	//FixedDeclaration:
	//    kind=Kind "<->" path=STRING
	//;
	public FixedDeclarationElements getFixedDeclarationAccess() {
		return pFixedDeclaration;
	}
	
	public ParserRule getFixedDeclarationRule() {
		return getFixedDeclarationAccess().getRule();
	}
	
	//enum Kind:
	//    KIND_INTERFACE="interface"|
	//    KIND_PACKAGE="package" |
	//    KIND_CLASS="class" |
	//    KIND_METHOD="method" |
	//    KIND_VAR="variable"
	//;
	public KindElements getKindAccess() {
		return eKind;
	}
	
	public EnumRule getKindRule() {
		return getKindAccess().getRule();
	}
	
	//Rule:
	//    "def" name=ID "for" kind=Kind "{"
	//        "filter" decls+=[Declaration] ("||" decls+=[Declaration])*
	//        "such" "that" "size" compOp=(">"|"<"|"=="|"<="|">=") compValue=INT
	//    "}" |
	//    "def" "declare" name=ID
	//;
	public RuleElements getRuleAccess() {
		return pRule;
	}
	
	public ParserRule getRuleRule() {
		return getRuleAccess().getRule();
	}
	
	//Case:
	//    "case" "for" kind=Kind condition=Expr "{"
	//        properties+=Property*
	//    "}"
	//;
	public CaseElements getCaseAccess() {
		return pCase;
	}
	
	public ParserRule getCaseRule() {
		return getCaseAccess().getRule();
	}
	
	//Expr: Or;
	public ExprElements getExprAccess() {
		return pExpr;
	}
	
	public ParserRule getExprRule() {
		return getExprAccess().getRule();
	}
	
	//Or returns Expr:
	//    And ({Or.left=current} "|" right=And)*;
	public OrElements getOrAccess() {
		return pOr;
	}
	
	public ParserRule getOrRule() {
		return getOrAccess().getRule();
	}
	
	//And returns Expr:
	//    Primary ({And.left=current} concatKind=("."|"...") right=Primary)*;
	public AndElements getAndAccess() {
		return pAnd;
	}
	
	public ParserRule getAndRule() {
		return getAndAccess().getRule();
	}
	
	//Primary returns Expr:
	//    GroupExpr |
	//    Atomic
	//;
	public PrimaryElements getPrimaryAccess() {
		return pPrimary;
	}
	
	public ParserRule getPrimaryRule() {
		return getPrimaryAccess().getRule();
	}
	
	//GroupExpr:
	//    hasNot?="!"? "(" expr=Expr ")" card=CardinalityModifier?
	//;
	public GroupExprElements getGroupExprAccess() {
		return pGroupExpr;
	}
	
	public ParserRule getGroupExprRule() {
		return getGroupExprAccess().getRule();
	}
	
	//Atomic returns Expr:
	//    {StringConst}
	//        hasNot?="!"? value=STRING card=CardinalityModifier? ("[" sentiment=Sentiment "]")? |
	//    {POSValue}
	//        hasNot?="!"? pos=POS card=CardinalityModifier? ("[" sentiment=Sentiment "]")? |
	//    {SynonymConst}
	//        hasNot?="!"? "#" value=STRING card=CardinalityModifier? ("[" sentiment=Sentiment "]")?
	//;
	public AtomicElements getAtomicAccess() {
		return pAtomic;
	}
	
	public ParserRule getAtomicRule() {
		return getAtomicAccess().getRule();
	}
	
	//enum Sentiment:
	//    SENT_UNSPECIFIED |
	//    SENT_NEUTRAL="neutral" |
	//    SENT_POSITIVE="positive" |
	//    SENT_NEGATIVE="negative"
	//;
	public SentimentElements getSentimentAccess() {
		return eSentiment;
	}
	
	public EnumRule getSentimentRule() {
		return getSentimentAccess().getRule();
	}
	
	//enum POS:
	//       POS_CC="CC" |
	//    POS_CD="CD" |
	//    POS_DT="DT" |
	//    POS_EX="EX" |
	//    POS_FW="FW" |
	//    POS_IN="IN" |
	//    POS_JJ="JJ" |
	//    POS_JJR="JJR" |
	//    POS_JJS="JJS" |
	//    POS_LS="LS" |
	//    POS_MD="MD" |
	//    POS_NN="NN" |
	//    POS_NNS="NNS" |
	//    POS_NNP="NNP" |
	//    POS_NNPS="NNPS" |
	//    POS_PDT="PDT" |
	//    POS_POS="POS" |
	//    POS_PRP="PRP" |
	//    POS_RB="RB" |
	//    POS_RBR="RBR" |
	//    POS_RBS="RBS" |
	//    POS_RP="RP" |
	//    POS_SYM="SYM" |
	//    POS_TO="TO" |
	//    POS_UH="UH" |
	//    POS_VB="VB" |
	//    POS_VBD="VBD" |
	//    POS_VBG="VBG" |
	//    POS_VBN="VBN" |
	//    POS_VBP="VBP" |
	//    POS_VBZ="VBZ" |
	//    POS_WDT="WDT" |
	//    POS_WP="WP" |
	//    POS_WRB="WRB"
	//;
	public POSElements getPOSAccess() {
		return ePOS;
	}
	
	public EnumRule getPOSRule() {
		return getPOSAccess().getRule();
	}
	
	//enum CardinalityModifier:
	//    CARD_1 |
	//    CARD_0_N="*" |
	//    CARD_1_N="+" |
	//    CARD_0_1="?"
	//;
	public CardinalityModifierElements getCardinalityModifierAccess() {
		return eCardinalityModifier;
	}
	
	public EnumRule getCardinalityModifierRule() {
		return getCardinalityModifierAccess().getRule();
	}
	
	//Property:
	//    frequency=Frequency? criterion=[Rule];
	public PropertyElements getPropertyAccess() {
		return pProperty;
	}
	
	public ParserRule getPropertyRule() {
		return getPropertyAccess().getRule();
	}
	
	//enum Frequency:
	//    ALWAYS="always" |
	//    VERYOFTEN="very-often" |
	//    OFTE="often" |
	//    RARELY="rarely" |
	//    VERYSELDOM="very-seldom" |
	//    NEVER="never"
	//;
	public FrequencyElements getFrequencyAccess() {
		return eFrequency;
	}
	
	public EnumRule getFrequencyRule() {
		return getFrequencyAccess().getRule();
	}
	
	//terminal ID: '^'?('a'..'z'|'A'..'Z'|'_') ('a'..'z'|'A'..'Z'|'_'|'0'..'9')*;
	public TerminalRule getIDRule() {
		return gaTerminals.getIDRule();
	}
	
	//terminal INT returns ecore::EInt: ('0'..'9')+;
	public TerminalRule getINTRule() {
		return gaTerminals.getINTRule();
	}
	
	//terminal STRING:
	//            '"' ( '\\' . /* 'b'|'t'|'n'|'f'|'r'|'u'|'"'|"'"|'\\' */ | !('\\'|'"') )* '"' |
	//            "'" ( '\\' . /* 'b'|'t'|'n'|'f'|'r'|'u'|'"'|"'"|'\\' */ | !('\\'|"'") )* "'"
	//        ;
	public TerminalRule getSTRINGRule() {
		return gaTerminals.getSTRINGRule();
	}
	
	//terminal ML_COMMENT : '/*' -> '*/';
	public TerminalRule getML_COMMENTRule() {
		return gaTerminals.getML_COMMENTRule();
	}
	
	//terminal SL_COMMENT : '//' !('\n'|'\r')* ('\r'? '\n')?;
	public TerminalRule getSL_COMMENTRule() {
		return gaTerminals.getSL_COMMENTRule();
	}
	
	//terminal WS         : (' '|'\t'|'\r'|'\n')+;
	public TerminalRule getWSRule() {
		return gaTerminals.getWSRule();
	}
	
	//terminal ANY_OTHER: .;
	public TerminalRule getANY_OTHERRule() {
		return gaTerminals.getANY_OTHERRule();
	}
}
